/*--------------------------------------------------------------*/
//LED8*8ʾ
//573ݣCPUɨ裬ɨ裬͵ƽЧ
#include <reg52.h>

/*--------------------------------------------------------------*/
//ӿڶ
sfr  DB = 0x90;
sbit LE = P3^7;
sbit OE = P3^6;
sbit K1 = P3^2;
sbit K2 = P3^3;
sbit K3 = P3^4;
sbit K4 = P3^5;
sbit K5 = P3^1;
sbit BP = P0^0;
sbit MT = P0^1;

/*--------------------------------------------------------------*/
//ȫֱ
#define len 30				//󳤶
unsigned char disram[8];	//ʾ
unsigned char x[len],y[len];//
bit on_off;					//ʾ,0--رգ1--
bit inverse;				//ɫʾ,0--رգ1--
char dx, dy;
unsigned char ID;
unsigned char speed;		//ƶٶ
unsigned char level;		//
unsigned char life;			//ֵ


void key_scan(void);

/*--------------------------------------------------------------*/
//ʱʼ
void T0_init(void)
{
    TMOD |= 0x01;
    TH0  = 0xf8;		//2ms
    TL0  = 0x36;
    IE  |= 0x82;
	PT0  = 1;
    TR0  = 1;
}


/*--------------------------------------------------------------*/
//ʱʼ
void T1_init(void)                    
{
    TMOD |= 0x10;
    TH1  = 0x00;        //65ms
    TL1  = 0x00;
    IE  |= 0x88;
    TR1  = 1;
}


/*-------------- ------------------------------------------------*/
//ʾ,
void clr_ram(void)
{
	unsigned char i;
	for(i = 0; i < 8; i++) 
		disram[i] = 0x00;
}


/*--------------------------------------------------------------*/
//㺯,һֻʾһ
//ϽΪ(0, 0)	½Ϊ(7, 7)
//Ϊx:0~7		Ϊy:0~7	
/*void gotoxy(unsigned char x, unsigned char y)
{
	clr_ram();
	disram[y] = 0x01 << x;
}


/*--------------------------------------------------------------*/
//㺯,ϴλͼ
//ϽΪ(0, 0)	½Ϊ(7, 7)
//Ϊx:0~7		Ϊy:0~7		
/*void point(unsigned char x, unsigned char y)
{
	disram[y] |= 0x01 << x;
}


/*--------------------------------------------------------------*/
//㺯,߻
//ϽΪ(0, 0)	½Ϊ(7, 7)
//Ϊx:0~7		Ϊy:0~7
//k = 1 --	  k = 0 --	
void point1(unsigned char x, unsigned char y, bit k)
{
	if(k) disram[y] |= 0x01 << x;
	else  disram[y] &= ~(0x01 << x);
}


/*--------------------------------------------------------------*/
//ʱжϷ
void T0_intservice(void) interrupt 1
{
	static unsigned char n;
	TR1 = 0;
    TH0  = 0xf8;						//2ms
    TL0  = 0x36;

	OE = 1;								//	
	if(on_off)	DB = 0x01 << n;			//ʼɨ
	else		DB = 0x00;				//رʾ
	LE = 1;								//
	LE = 0;								//
	if(inverse)	DB = disram[n];			//ɫʾ
	else		DB = ~disram[n];		//ʾ
	OE = 0;								//ʾ
	
	n++; if(n == 8) n = 0;				//ѭɨ
	TR1 = 1;
}


/*--------------------------------------------------------------*/
//ʱжϷ
void T1_intservice(void) interrupt 3
{
	TH1  = 0x00;
    TL1  = 0x00;
	key_scan();
}


/*--------------------------------------------------------------*/
//ʱ100000+1us 
void delay(void)
{
    unsigned char i,j,k;
    for(i=156;i>0;i--)
    for(j=58;j>0;j--)
    for(k=4;k>0;k--);
}


/*--------------------------------------------------------------*/
//
void beep(void)
{
	BP = 0;
	delay();
	BP = 1;
}
	


/*--------------------------------------------------------------*/
//ɨ 
void key_scan(void)
{
	if(K1 == 0)					//
	{
		if(ID == 0) {dx = 0; dy = -1;}
		if(ID == 1 && speed > 1)	//
		{
			speed--;
			beep();					//ָʾ
		 	while(K1 == 0);
		}
		if(ID == 2 && level < 17)  //ѡ
		{
			level++;
			beep();					//ָʾ
			while(K1 == 0);
		}
	}
	if(K2 == 0)					//
	{
		if(ID == 0) {dx = 0; dy = 1;}
		if(ID == 1 && speed < 15)	//
		{
			speed++;
			beep();					//ָʾ
			while(K2 == 0);
		}
		if(ID == 2 && level > 0)	//ѡ
		{
			level--;
			beep();					//ָʾ
			while(K2 == 0);
		}
		
	} 
	if(K3 == 0)					//
	{
		if(ID == 0) {dy = 0; dx = -1;}
		if(ID == 1) inverse = 0;		//ʾ
		if(ID == 2) on_off = 1;			//ʾ
		
	}
	if(K4 == 0)					//
	{
		if(ID == 0) {dy = 0; dx = 1;}
		if(ID == 1) inverse = 1;		//ɫʾ
		if(ID == 2) on_off = 0;			//رʾ
	}
	if(K5 == 0)					//
	{
		ID++; if(ID == 4) ID = 0;
		beep();							//ָʾ
		while(K5 == 0);
	}		
}


/*--------------------------------------------------------------*/
//ʾһֻʾһ
void gotoxy(unsigned char x, unsigned char y)
{
	OE = 1;								//	
	DB = (0x01 << y);					
	LE = 1;								//
	LE = 0;								//

	DB = ~(0x01 << x);					
	OE = 0;								//ʾ

	beep();								//ָʾ
	delay();
}


/*--------------------------------------------------------------*/
//ͨʾ
void congrate(void)
{
	char i, j;
	TR0 = 0;
	TR1 = 0;

	for(j = 0; j < 5; j++)
	{
		for(i = j ; i < 8-j; i++)gotoxy(j, i);
		for(i = j+1 ; i < 8-j; i++)gotoxy(i, 7-j);
		for(i = j+1 ; i < 8-j; i++)gotoxy(7-j, 7-i);
		for(i = j+1 ; i < 7-j; i++)gotoxy(7-i, j);
	}

	for(j = 4; j >= 0; j--)
	{
		for(i = 6-j ; i >= j+1; i--)gotoxy(7-i, j);
		for(i = 7-j ; i >= j+1; i--)gotoxy(7-j, 7-i);
		for(i = 7-j ; i >= j+1; i--)gotoxy(i, 7-j);
		for(i = 7-j ; i >= j; i--)gotoxy(j, i);	
	}
}


/*--------------------------------------------------------------*/
//
void main (void)
{	
	unsigned char i;			//ͨѭ
	unsigned char num;			//ߵĳ
	bit food, over;				//ʳͽ־λ
	unsigned char foodx, foody;	//ʳ
	
	life = 3;
	speed = 8;
	num = 2;
	T0_init();					//ʱʼ
	T1_init();
	on_off = 1;					//ʾ
	inverse = 0;				//ʾ
	clr_ram();					//ʾ
	x[0] = 1;					//ʼλ
	y[0] = 2; 
	dx = 1;						//˶
	while(1)
	{
		x[0] += dx;	y[0] += dy;
		x[0] &= 0x07; y[0] &= 0x07;			//ǽ
	
		if(!food) 							//ʳ
		{
again:		foodx = TL0&0x07; 				//
			foody = TH0&0x07; 
			for(i = 0; i < num; i++)
			{
				if(foodx == x[i] && foody == y[i])
				goto again;
			}
			point1(foodx, foody, 1);		//ʾʳ
			food = 1;						//ʳ־λ
		}

		if(x[0] == foodx && y[0] == foody)	//Եʳ	
		{
			beep();							//ָʾ
			num++;							//߳1
			food = 0;						//ʳ־λ
		}

		for(i = 0; i < num; i++)			//ʾ
		point1(x[i], y[i], 1);
		point1(x[i], y[i], 0);				//β

		for(i = 1; i < num; i++)			//жǷײ
		{
			if((x[0] == x[i]) && (y[0] == y[i]))
			over = 1;						//ý־λ
		}

		for(i = 0; i < speed; i++) delay();	//˶ٶ
		
		for(i = 0; i < num; i++)			//ƶ
		{
			x[num-i] = x[num-i-1]; 
			y[num-i] = y[num-i-1];
		}
		
/*		if(x[0]>7||y[0]>7)					//жǷײǽ
		{
			over = 1;						//ý־λ
		}
*/	
		if(num > 10 + level) 				//
		{
			if(num > 28)					//ͨ!!!
			{
				while(1){congrate();inverse = ~inverse;}
			}
			delay(); beep();				//ָʾ
			MT = 0; delay(); MT = 1; 		//ָʾ
			if(speed > 1) speed--;			//ٶȼһ
			num = 2;						//ض߳
			level += 1;						//ܵ߳1
			clr_ram();						//Ļ
			goto again;						//µһؿʼ
		}

		if(over)							//жǷ
		{
			MT = 0; delay(); MT = 1; 		//ָʾ
			clr_ram();						//Ļ
			num = 2;						//趨߳
			point1(foodx, foody, 1); 		//·ʳ
			x[0] = 1; y[0] = 2;				//λ
			dx = 1;							//˶
			over = 0;						//־λ
			life--;							//ֵ1
		}	
		if(!life)	congrate();
	}
}





