/*--------------------------------------------------------------*/
//LED8*8ʾ
//573ݣCPUɨ裬ɨ裬͵ƽЧ
#include <reg52.h>


/*--------------------------------------------------------------*/
//ӿڶ
sfr  DB = 0x90;
sbit LE = P3^7;
sbit OE = P3^6;
sbit K1 = P3^2;
sbit K2 = P3^3;
sbit K3 = P3^4;
sbit K4 = P3^5;
sbit K5 = P3^1;
sbit BP = P0^0;
sbit MT = P0^1;

/*--------------------------------------------------------------*/
//ȫֱ
unsigned char disram[8];	//ʾ
bit on_off;					//ʾ,0--رգ1--
bit inverse;				//ɫʾ,0--رգ1--
char a, b;


/*--------------------------------------------------------------*/
//ʱʼ
void T0_init(void)
{
    TMOD = 0x01;
    TH0  = 0xf8;		//2ms
    TL0  = 0x36;
    IE   = 0x82;
    TR0  = 1;
}


/*-------------- ------------------------------------------------*/
//ʾ,
void clr_ram(void)
{
	unsigned char i;
	for(i = 0; i < 8; i++) 
		disram[i] = 0x00;
}


/*--------------------------------------------------------------*/
//㺯,һֻʾһ
//ϽΪ(0, 0)	½Ϊ(7, 7)
//Ϊx:0~7		Ϊy:0~7	
/*void gotoxy(unsigned char x, unsigned char y)
{
	clr_ram();
	disram[y] = 0x01 << x;
}


/*--------------------------------------------------------------*/
//㺯,ϴλͼ
//ϽΪ(0, 0)	½Ϊ(7, 7)
//Ϊx:0~7		Ϊy:0~7		
/*void point(unsigned char x, unsigned char y)
{
	disram[y] |= 0x01 << x;
}


/*--------------------------------------------------------------*/
//㺯,߻
//ϽΪ(0, 0)	½Ϊ(7, 7)
//Ϊx:0~7		Ϊy:0~7
//k = 1 --	  k = 0 --	
void point1(unsigned char x, unsigned char y, bit k)
{
	if(k) disram[y] |= 0x01 << x;
	else  disram[y] &= ~(0x01 << x);
}


/*--------------------------------------------------------------*/
//ʱжϷ
void T0_intservice(void) interrupt 1
{
	static unsigned char n;
    TH0  = 0xf8;						//2ms
    TL0  = 0x36;

	OE = 1;								//	
	if(on_off)	DB = 0x01 << n;			//ʼɨ
	else		DB = 0x00;				//رʾ
	LE = 1;								//
	LE = 0;								//
	if(inverse)	DB = disram[n];			//ɫʾ
	else		DB = ~disram[n];		//ʾ
	OE = 0;								//ʾ
	
	n++; if(n == 8) n = 0;				//ѭɨ
}


/*--------------------------------------------------------------*/
//ʱ5000+0us 
void delay1(void)
{
    unsigned char i, j;
    for(i = 185; i > 0; i--)
    for(j = 12; j > 0; j--);
}


//ʱ200000+0us 
void delay(void)
{
    unsigned char i,j,k;
    for(i=201;i>0;i--)
    for(j=32;j>0;j--)
    for(k=14;k>0;k--);
}


/*--------------------------------------------------------------*/
//ɨ 
void key_scan(void)
{
	static bit m;
	if(K1 == 0)	{delay1(); if(K1 == 0) {point1(a, b, m);b--; while(K1 == 0);}}
	if(K2 == 0)	{delay1(); if(K2 == 0) {point1(a, b, m);b++; while(K2 == 0);}} 
	if(K3 == 0)	{delay1(); if(K3 == 0) {point1(a, b, m);a--; while(K3 == 0);}}
	if(K4 == 0)	{delay1(); if(K4 == 0) {point1(a, b, m);a++; while(K4 == 0);}}
	if(K5 == 0)	{delay1(); if(K5 == 0) {m = ~m; delay(); if(K5 == 0) {clr_ram();BP = 0;delay();BP = 1;}while(K5 == 0);}}
}


/*--------------------------------------------------------------*/
//
void main (void)
{	
	bit k;
	T0_init();				//ʱʼ
	on_off = 1;				//ʾ
	inverse = 0;			//ʾ
	clr_ram();				//ʾ
	while(1)
	{
		key_scan();
		point1(a, b, k);
		delay();
		k = ~k;
	}
}





